<?php
/*********************
 *  Diablo 3 Tolltip for Wordpress
 *
 *  Function file.
 *
 *  This file just contains all neccesary function
 *  no code execution is done directly in this function file!
 *
 *  written by Marco 'solariz' Goetze
 *  http://www.solariz.de
 *
 **********************/



/**
 * function d3tt_print_scripts
 * Add Scripts
 * @version 1.0
 * @author Marco 'solariz' Goetze
 * @return bool
 */
function d3tt_print_scripts() {
    GLOBAL $D3TT_JSURI;
    /*
        wp_register_style("d3t_css","http://eu.battle.net/d3/static/css/tooltips.css");
        wp_enqueue_style("d3t_css");
    */
    if (is_admin()) {
        return false;
    } else {
        wp_deregister_script('d3tt_tooltips');
        $d3tt_JS_SRC = d3tt_getBlizzardJS();
        if(d3tt_usedebugJS == true) {
            // Only for my local testing
            if( file_exists("d3debug.js") ) {
                $d3tt_JS_SRC = d3tt_pluginPath(false)."d3debug.js";
                // http://eu.battle.net/d3/en/tooltip/item/royal-dye?format=jsonp
            }
        }
        wp_register_script('d3tt_tooltips', $d3tt_JS_SRC);
        if(d3tt_getConf('d3tt_JS2Head')) {
            // wp_enqueue_script( $handle,$src,$deps,$ver,$in_footer);
            wp_enqueue_script( 'd3tt_tooltips',false,array(),false,false);
        } else {
            add_action('wp_footer', 'd3tt_footer_workaround');
        }//end:if
    }//end:if admin
}//end:d3tt_print_scripts


/**
 * function d3tt_footer_workaround
 * This is a workaround because currently the wp_enqueue_script to footer
 * native function of wordpress doesent seem to work as intended. In some
 * cases it still add to the header even if i try to force the footer.
 * This function works around this by inserting the JS manually in the footer
 * processor. Hope to remove this soon.
 * @version 1.0
 * @author Marco 'solariz' Goetze
 * @return false
 */
function d3tt_footer_workaround() {
    wp_enqueue_script( 'd3tt_tooltips',false,array(),false,true);
}


/**
 * function d3tt_configPage
 * Contains plugin WP settings page
 * @version 1.0
 * @author Marco 'solariz' Goetze
 * @return bool
 */
function d3tt_configPage() {
    if (current_user_can('manage_options'))
    {
        if (function_exists('add_options_page'))
        {
            require_once(d3tt_pluginPath(true).'d3tt-settings.php');
            add_options_page('Diablo 3 Tooltip for Wordpress Settings', 'Diablo 3 Tooltip', 8, __FILE__, 'd3tt_settings_page');
        }
    }
}//end:d3tt_configPage

/**
 * function d3tt_addAdminInit
 * Init of Admin Settings / Stuff
 * @version 1.0
 * @author Marco 'solariz' Goetze
 * @return bool
 */
function d3tt_addAdminInit() {
    wp_register_style('d3tt_SettingsCSS', d3tt_pluginPath(false)."css/wp_settings.css");
    wp_enqueue_style( 'd3tt_SettingsCSS');
}//end:d3tt_addAdminInit

/**
 * function d3tt_settingsLink
 * Add settings link on plugin page
 * @version 1.0
 * @author Marco 'solariz' Goetze
 * @return string
 */
function d3tt_settingsLink($links) {
  $settings_link = '<a href="options-general.php?page=diablo3-tooltip/d3tt-functions.php">Settings</a>';
  array_unshift($links, $settings_link);
  return $links;
}//end:d3tt_settingsLink


/**
 * function d3tt_pluginPath
 * Return the actual URL or Hardpath of the plugin
 * @version 1.0
 * @author Marco 'solariz' Goetze
 * @return string
 */
function d3tt_pluginPath($hardpath = true) {
    if($hardpath == true) {
        // Return Path
        return trailingslashit(ABSPATH.'wp-content/plugins/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)));
    } else {
        // Return URI
        $URL = trailingslashit(WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)));
        if(is_ssl()) $URL = preg_replace('/^http:\/\//', 'https://',  $URL);
        return $URL;
    }
}//end:d3tt_pluginPath


/**
 * function d3tt_getBlizzardJS
 * Return the actual URL of the Blizzard D3 tooltips.JS
 * @version 1.0
 * @author Marco 'solariz' Goetze
 * @return string
 */
function d3tt_getBlizzardJS() {
    global $D3TT_JSURI;
    $URI = @$D3TT_JSURI[d3tt_getConf('d3tt_server')];
    if(!isset($URI)) {
        // Default Fallback to USA Server
        return $D3TT_JSURI['us'];
    } else {
        // Uri found in our array, returnig a valid blizzard server
        return $URI;
    }
}//end:d3tt_getBlizzardJS

/**
 * function d3tt_selector
 * Function to fill <select> with <option>'s
 * @version 1.0
 * @param array $array
 * @param bool $selected
 * @author Marco 'solariz' Goetze
 * @return string
 */
function d3tt_selector($array,$selected=false) {
    $OUT = '';
    foreach($array as $k=>$v) {
        $s=($k==$selected&&$selected!=false)?' selected ':'';
        $OUT .= '<option value="'.$k.'"'.$s.'>'.$v.'</option>';
    }
    return $OUT;
}//end:d3tt_selector





/**
 * function d3tt_getConf
 * read the Config from WP in case of multisite it return the multisite value as default
 * @version 1.0
 * @author Marco 'solariz' Goetze
 * @return value
 */
function d3tt_getConf($key,$default=false)
{
    $value = get_option($key);
    if($value == false)
    {
        // If Multisite installation try to get the global network default
        if(function_exists('is_multisite')) if(is_multisite()) $value = get_site_option($key);
    }
    if(!isset($value) && $default !== false) $value = $default;
    if(@$value == "off" || isset($value) != true) $value = false;
    return $value;
}//end:d3tt_getConf



/**
 * function d3tt_contentFilter
 * Replace the Shortcodes by actual Links or what ever is needed
 * @version 1.0
 * @author Marco 'solariz' Goetze
 * @return value
 */
function d3tt_contentFilter($content)
{
    GLOBAL $D3TT_LINKBASE;
    if(!isset($content)) return false;
    $regex = '#\[d3\](.*)\[/d3]#i';
    $target = "_blank"; // TODO: Add this to config
    preg_match_all($regex, $content, $matches);
    // Check if at least 1 match was found, if not return content as it is.
    if(defined('D3TT_DEBUG')) echo "<p style=\"background-color: #DDDDFF\"><strong>\$matches</strong><br>".nl2br(print_r($matches,true))."</p>";
    if(count($matches) > 0) {
           $URI = @$D3TT_LINKBASE[d3tt_getConf('d3tt_server')];
            // ok at least one bb code match was found, replace it
            if(defined('D3TT_DEBUG')) echo "<p style=\"background-color: #ffDDDD\"><strong>for( \$matches )</strong></p>";
            for ($i=0; $i<=count($matches)+1; $i++) {
                if(defined('D3TT_DEBUG')) echo "<p style=\"background-color: #ffDDDD\">[".$i."] = ".$matches[0][$i]." | ".$matches[1][$i]."</p>";
                // Plain link: <a href="/d3/en/item/echoing-fury">item</a>
                $LINK = '<a href="'.$URI.'en/%s" target="'.$target.'">%s</a>';
                if(isset($matches[0][$i])) {
                    // Check if a detailed definition is present, if not I guess the user want to link a item
                    if( stristr($matches[1][$i], "/") ) {
                        $item = trim($matches[1][$i]);
                        // Detailed definition could be anything from items to a spell
                        // we need to explode the slashes and only display the last
                        // content.
                        $tmp = explode("/", $item);
                        $item_named = str_replace(array("\\","/","*","&",";","-"), " ", strip_tags(($tmp[count($tmp)-1])));
                        $item_named = str_replace("  ", " ", $item_named);
                        // To have it look like intended go through the single words and capitalize them
                        $tmp = explode(" ",$item_named);
                        $doNotCapitalize = array("of","the","a","from","vanished");
                        $item_named = "";
                        foreach ($tmp as $word) {
                            $word = strtolower($word);
                            if(in_array($word, $doNotCapitalize) == false) {
                                $item_named .= ucfirst($word)." ";
                            } else {
                                $item_named .= $word." ";
                            }
                        }
                        unset($tmp,$word,$doNotCapitalize);
                    } else {
                        $item = "item/".trim($matches[1][$i]);
                        $item_named  = str_replace(array("\\","/","*","&",";"), "", strip_tags($matches[1][$i]));
                    }
                    $item_linkified = strtolower(str_replace(" ", "-", $item));
                    $content = str_replace($matches[0][$i], sprintf($LINK,$item_linkified,$item_named), $content);
                }//end:if
                // Safety regulation, kill for after 50 matches.
                // It is not very likely that somebody will link more than 50 Items in one content
                if($i > 50) break;
            }//end:for
    }//end:if



    return $content;
}//end:d3tt_contentFilter


/**
 * function d3tt_conditionally_scriptLoad
 * Add required JS or CSS only if neccesary,
 * function by beerpla:
 * http://beerpla.net/2010/01/13/wordpress-plugin-development-how-to-include-css-and-javascript-conditionally-and-only-when-needed-by-the-posts/
 * @version 1.0
 * @author Artem Russakovskii
 * @return value
 */
function d3tt_conditionally_scriptLoad($posts){

    if (empty($posts)) return $posts;
    $shortcode_found = false; // use this flag to see if styles and scripts need to be enqueued
    foreach ($posts as $post) {
        if (stripos($post->post_content, '[d3]') !== false) {
            $shortcode_found = true; // bingo!
            break;
        }
    }
    if ($shortcode_found) {
        d3tt_print_scripts();
    }
    return $posts;
}//end:d3tt_conditionally_scriptLoad