<?php
/*
Plugin Name: Diablo 3 Tooltip
Plugin URI: http://solariz.de/diablo-3-tooltip-for-wordpress
Description: Add configurable Diablo 3 Tooltip Support to your Wordpress Installation, including Auto inclusion of neccesary JS only when needed.
Version: 1.0
Author: Marco Goetze
Author URI: http://solariz.de

    This program is distributed WITHOUT ANY WARRANTY
*/



/*****************************
//  SETUP & DEFAULTS
/*****************************/
    $D3TT_JSURI = array("us"=>"http://us.battle.net/d3/static/js/tooltips.js",
                                        "eu"=>"http://eu.battle.net/d3/static/js/tooltips.js");
    $D3TT_LINKBASE = array("us"=>"http://us.battle.net/d3/",
                                               "eu"=>"http://eu.battle.net/d3/");
    $D3_CONTENT_FOUND = false;
    $thisPlugin = plugin_basename(__FILE__);
    define("d3tt_usedebugJS", false);
    // define("D3TT_DEBUG", true);
    require_once('d3tt-functions.php');


/*****************************/
//  CHECKS
/*****************************/
// security direct call check
    if ( !function_exists( 'add_action' ) ) {
        echo "Hi there!<br/>I'm just a mousy plugin, not much I can do when called directly.<br/>Please leave me alone, alone in the dark - hunting for epic treasures...";
        exit;
    }
// PHP Version check
    if( floatval(phpversion()) < 5 ) {
        // PHP < 5
        if( is_admin() ) echo "<div id='warning' class='updated fade'><p><strong>".__('PHP Version seems outdated.')."</strong> ".'The Plugin "Diablo 3 Tooltip" need at least PHP 5.0 to work.'."</p></div>";
        return false;
    }



/*****************************/
//  WORDPRESS CALLS
/*****************************/

// Action & Filters
if(is_admin()) {
    add_action('admin_menu', 'd3tt_configPage');    // Settings Page
    add_action('admin_init', 'd3tt_addAdminInit');
    add_filter("plugin_action_links_".$thisPlugin, 'd3tt_settingsLink' ); // Settings Link
} else {
    add_filter('the_posts', 'd3tt_conditionally_scriptLoad');
    // Workaround cause wp_enque seems to behave strange on site init
    // force footer did not always work, with this method it is safe.
    /*
    if(d3tt_getConf('d3tt_JS2Head')) {
        add_action('wp_print_scripts', 'd3tt_print_scripts');
    } else {
        add_action('wp_print_scripts', 'd3tt_print_scripts');
    }
    */
    // add the filter for the shortcodes
    add_filter( 'the_content', 'd3tt_contentFilter' );
}//end:is_admin






